#include <system.h> 
#include <string.h>
#pragma CLOCK_FREQ	4000000

#include "SerialLib.h"

void initMain() {

// most of this has nothing to do with the serial stuff, probably ok to drop but
// i am not ready to test this now 
// looks like some ustart init code should be removed??
	//Configure port A  update july 28 08``-- out if not currently used
	porta   = 0b00000000; 
	// 	  	  0b76543210
	//trisa 	= 0b00000110; 
	// this is for the up down button -- check a to d for conflict 
	trisa 	= 0b00110000; 
 	// 		  0b76543210
 	 
	//Configure port B  update july 28 08``-- out if not currently used
	// check that this is MODE_PORT which get the clock on .0 ?
	portb   = 0b00000000;
	// 		  0b76543210
	trisb 	= 0b00000000; // output better than floating input?
	//trisb 	= 0b00111111;   was 
	//trisb 	= 0b00001111;    // led then pb
   

	//Configure port C  update july 28 08``-- out if not currently used
	portc   = 0b00000000;
	// 		  0b76543210
	trisc 	= 0b11000000; 	// ustart is here, this may be important or not 
	
	//Configure port D  update july 28 08``-- out if not currently used
	portd   = 0b00000000;
	// 		  0b76543210
	trisd 	= 0b00000000; 
	
	//Configure port E  update july 28 08``-- out if not currently used
	porte  	= 0b00000000;
	// 		 0b76543210	
	trise 	= 0b00000000;    //0, 1, 2 are all that exist

	//Configure A/D pins
	//adcon1 = 0x06;     // 0x06 = 0b00000110 which is what?  looks like analog to me

	//Set Timer0 mode
	clear_bit( option_reg, T0CS ); //configure timer0 as a timer
	//Set prescaler assignment
	clear_bit( option_reg, PSA ); //prescaler is assigned to timer0
	//Set prescaler rate
	clear_bit( option_reg, PS2 ); //prescaler rate 1:2
	clear_bit( option_reg, PS1 );
	clear_bit( option_reg, PS0 );
	//Set timer0 source edge selection
	set_bit( option_reg, T0SE ); //increment on high-to-low transition on RA4/T0CKI pin

	//Set timer 1 prescaler rate
	clear_bit( t1con, T1CKPS1 ); //prescaler rate 1:1
	clear_bit( t1con, T1CKPS0 );
	//Set timer 1 mode
	clear_bit( t1con, TMR1ON ); //disable timer 1

	//Set timer 2 prescaler rate
	clear_bit( t2con, T2CKPS1 ); //prescaler rate 1:1
	clear_bit( t2con, T2CKPS0 );
	//Set timer 2 postscaler rate
	clear_bit( t2con, TOUTPS3 ); //postscaler rate 1:1
	clear_bit( t2con, TOUTPS2 );
	clear_bit( t2con, TOUTPS1 );
	clear_bit( t2con, TOUTPS0 );
	//Set timer 2 mode (enable or disable)
	clear_bit( t2con, TMR2ON ); //enable timer 2

	// ---- timer 1 set up
	
	// 871 timer 1
	//t1con
	//bit 7-6 Unimplemented: Read as '0'
	//bit 5-4 T1CKPS1:T1CKPS0: Timer1 Input Clock Prescale Select bits
	//11 = 1:8 Prescale value
	//10 = 1:4 Prescale value
	//01 = 1:2 Prescale value
	//00 = 1:1 Prescale value
	clear_bit( t1con, T1CKPS1 );
	clear_bit( t1con, T1CKPS0 );
	//bit 3 T1OSCEN: Timer1 Oscillator Enable Control bit
	//1 = Oscillator is enabled
	//0 = Oscillator is shut-off (the oscillator inverter is turned off to eliminate power drain)
	//bit 2 T1SYNC: Timer1 External Clock Input Synchronization Control bit
	//When TMR1CS = 1:
	//1 = Do not synchronize external clock input
	//0 = Synchronize external clock input
	//When TMR1CS = 0:
	//This bit is ignored. Timer1 uses the internal clock when TMR1CS = 0.
	//bit 1 TMR1CS: Timer1 Clock Source Select bit
	//1 = External clock from pin RC0/T1OSO/T1CKI (on the rising edge)
	//0 = Internal clock (FOSC/4)
	clear_bit( t1con, TMR1CS );
	pir1		= 0x0; //disable everything
	intcon 		= 0x0; // disable everything
	//set_bit( pie1, TMR1IE ); // timer 1 interrupt enable		
	//set_bit( intcon, PEIE );  // enable perif inc timer 1 on 
	//PEIE: Peripheral Interrupt Enable bit, 1 = Enables all un-masked peripheral interrupts, 0 = Disables all peripheral interrupts
	
	//bit 0 TMR1ON: Timer1 On bit
	//1 = Enables Timer1
	//0 = Stops Timer1

	//set_bit( t1con, TMR1ON );  // set = timer1 on

	// ====== configure USART ====== //
    
    #ifdef DEF_CLOCK_20MEG
		#warning "#DEFINE 20 meg hz clock 19.2 baud"
		spbrg 	= B19_2AT20MEG;
	#endif // DEF_CLOCK_20MEG
	
	#ifdef DEF_CLOCK_4MEG
		#warning "#DEFINE 4 meg hz clock 19.2 baud"
		spbrg 	= B19_2At4MEG;
	#endif // DEF_CLOCK_4MEG
	
	
	// this stuff is needed, maybe for command init 											
	CmdPrior[0]   	= 0;   		// a null string
	resetCmd(  );
	GotCmd 			= 0; 		// not got a cmd
	cmdStatus 		= CMD_STATUS_ADD;  // should some of this be in resetCmd ??
	stopFlag		= 0;		// not in stop mode
	

// make sure ports are not analog
// porte, 1

// 011x D D D D D D D D VDD VSS 0/0

	// adcon0 is used in actual conversion not in configuration of ports
	// set_bit( adcon1
	//           76543210
	adcon1   = 0b00000110;    // 00000110 all anlog/digiatal to digital, format to ?
	
}
void rptVersion( ) {

	serial_printf( "DemoSerial.c version = Dec 16 2008 b" );
	serial_printf( END_RESPONSE_SEP ); 
	// return;  would be optmized out 
}

// =========== subroutine ==========
// echo characters recieved ( up to cr ) as space seperated hex
// values.  May help you figure out what is comming in on the serial
// line.  Note that special characters like cr and backspace will not
// be passed thru.
// get out of this by using the stop character
// arguments:	none
// 		globals: none 
//	demoEcho()
//	
// to do 	
//			

	void	demoEcho() {
	
		serial_printf( END_RESPONSE_SEP ); 
		serial_printf( "demoEcho" ); 
		serial_printf( END_RESPONSE_SEP ); 	
		
		while(1)   {

			// stopFlag -- get you out of this subroutine
			if ( stopFlag  )   {
				return;
			}
			
			if ( GotCmd  )   {
				GotCmd 		= 0; // set to 0 when you process the command
			    char i 		= 0;
			    serial_printf( "echo = " ); 
				while( CmdPrior[i] != 0) {
					serial_print_hex( CmdPrior[i++] );
					serial_printf( " " ); 
				}
				
				serial_printf( END_RESPONSE_SEP ); 
					   
			}
		}			
		
		return;
	}


// =========== interrupt ==========
// process the interrupts -- UART is interrupt drive, this is required.
void interrupt( void )  {
    
	if( rcif )  { //UART Recieve Interrupt      
		tryRecCmd();
        return;  
    }

	//Handle timer0 interrupt -- not used
	if( intcon & (1<<T0IF) ) {
		clear_bit( intcon, T0IF ); //clear timer 0 interrupt bit
	}

	//Handle timer1 interrupt -- not used
	if( pir1 & (1<<TMR1IF) )  {
		clear_bit( pir1, TMR1IF ); //clear timer 1 interrupt bit
	}

	//Handle timer2 interrupt -- not used
	if( pir1 & (1<<TMR2IF) )     {
		clear_bit( pir1, TMR2IF ); //clear timer 2 interrupt bit
	}
	
	clear_bit( t1con, TMR1ON );   // clear = timer1 off

}

void main() {
	initMain();
	
	serial_init877( 25 );   //9600	@ 4 meg  see base conversion spread sheet  
	recieveInterruptOn(  );	
	set_bit( intcon, GIE );   // set = global enable we are off counting time
	
	rptVersion( );
	
	while(1) {
		if ( stopFlag  )   {
			stopFlag 	= 0;
			GotCmd 		= 0;
		}
			unsigned char  	locCmd;
		signed int		CmdPriorNbr;

		if ( GotCmd  )   {
			
			locCmd   = CmdPrior[0];     // in case access to array is expensive
			
			// make command case insensitive
			// lower case the command as necessary // combine with above and make sub, possibly inline ?
			if ( locCmd < 97 ) {
				locCmd += 32;
			}	
			
			// decode command
			switch ( locCmd )  {
				 	  
				case 'e':
					demoEcho();
					break;	
				case 'n':
					CmdPriorNbr = parseCmdNbr( CmdPrior );
					serial_printf( "numero = " );
					serial_print_dec( CmdPriorNbr );
					serial_printf( END_RESPONSE_SEP );  // 
					break;	
					 
				case 'v':
					// report version
					rptVersion( );
					break;
				
				default:
					serial_printf( "Bad Command = " );
					serial_printf( CmdPrior );
					serial_printf( END_RESPONSE_SEP );
			}
			// change to reset command no -- 
			GotCmd 		= 0;
			//cmdStatus 	= CMD_STATUS_ADD;  // removed should be internal to interrupt routine or serialCmd
			
		}
		delay_ms(5);
                
		endofmainwhile:
		//return;	
	}

}


